package com.nisum.webfluxday2.service;

import com.nisum.webfluxday2.repository.ProductRepository;
import com.nisum.webfluxday2.model.Product;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class ProductService {

    @Autowired
    ProductRepository productRepository;

    public Flux<Product> getAll() {
        return productRepository.findAll();
    }

    public Mono<Product> addProduct(Product product) {

        return productRepository.insert(new Product(product));
    }

    public Mono<Product> findProduct(String id) {
        return productRepository.findById(id);
    }

    public Mono<Product> alterProduct(String id, Product product) {

        System.out.println("put service");

//        Mono<Product> updatedProduct = productRepository.findById(id)
//                .map(prod -> prod.updateProduct(product))
//                .;
        return productRepository.save(product);

    }


    public Mono<Void> deleteProduct(String id) {
        return productRepository.deleteById(id);
    }
}
